#ifndef TEXTURE_H_
#define TEXTURE_H_

#include <glib-object.h>
#include "uobject.h"

#define ENGINE_TEXTURE_TYPE (engine_texture_get_type())
#define ENGINE_TEXTURE(obj) \
	G_TYPE_CHECK_INSTANCE_CAST(obj, ENGINE_TEXTURE_TYPE, EngineTexture)
#define ENGINE_TEXTURE_CLASS(class) \
	G_TYPE_CHECK_CLASS_CAST(class, ENGINE_TEXTURE_TYPE, EngineTextureClass)
#define ENGINE_IS_TEXTURE(obj) \
	G_TYPE_CHECK_INSTANCE_TYPE(obj, ENGINE_TEXTURE_TYPE)
#define ENGINE_IS_TEXTURE_CLASS(class) \
	G_TYPE_CHECK_CLASS_TYPE(class, ENGINE_TEXTURE_TYPE, EngineTextureClass)

typedef struct EngineTexture      EngineTexture;
typedef struct EngineTextureClass EngineTextureClass;

struct EngineTexture {
	UObject parent;

	unsigned int usize, vsize;
};

struct EngineTextureClass {
	UObjectClass parent;
};

GType engine_texture_get_type(void);
void texture_register(GTypeModule *m);

#endif
